src/Pure/build-jars
author wenzelm
Mon Nov 06 17:21:32 2017 +0100 (18 months ago)
changeset 67016 57d58c3cf16b
parent 66959 015d47486fc8
child 67041 f8b0367046bd
permissions -rwxr-xr-x
minimal document model for theory files;
     1 #!/usr/bin/env bash
     2 #
     3 # Author: Makarius
     4 #
     5 # build-jars - build Isabelle/Scala
     6 #
     7 # Requires proper Isabelle settings environment.
     8 
     9 ## sources
    10 
    11 declare -a SOURCES=(
    12   Admin/afp.scala
    13   Admin/build_cygwin.scala
    14   Admin/build_doc.scala
    15   Admin/build_history.scala
    16   Admin/build_jdk.scala
    17   Admin/build_log.scala
    18   Admin/build_polyml.scala
    19   Admin/build_release.scala
    20   Admin/build_status.scala
    21   Admin/check_sources.scala
    22   Admin/ci_profile.scala
    23   Admin/isabelle_cronjob.scala
    24   Admin/isabelle_devel.scala
    25   Admin/jenkins.scala
    26   Admin/news.scala
    27   Admin/other_isabelle.scala
    28   Admin/remote_dmg.scala
    29   Concurrent/consumer_thread.scala
    30   Concurrent/counter.scala
    31   Concurrent/event_timer.scala
    32   Concurrent/future.scala
    33   Concurrent/mailbox.scala
    34   Concurrent/par_list.scala
    35   Concurrent/standard_thread.scala
    36   Concurrent/synchronized.scala
    37   GUI/color_value.scala
    38   GUI/gui.scala
    39   GUI/gui_thread.scala
    40   GUI/html5_panel.scala
    41   GUI/jfx_gui.scala
    42   GUI/popup.scala
    43   GUI/wrap_panel.scala
    44   General/antiquote.scala
    45   General/bytes.scala
    46   General/codepoint.scala
    47   General/completion.scala
    48   General/date.scala
    49   General/exn.scala
    50   General/file.scala
    51   General/file_watcher.scala
    52   General/graph.scala
    53   General/graph_display.scala
    54   General/graphics_file.scala
    55   General/http.scala
    56   General/json.scala
    57   General/linear_set.scala
    58   General/logger.scala
    59   General/long_name.scala
    60   General/mercurial.scala
    61   General/multi_map.scala
    62   General/output.scala
    63   General/path.scala
    64   General/position.scala
    65   General/pretty.scala
    66   General/properties.scala
    67   General/scan.scala
    68   General/sha1.scala
    69   General/sql.scala
    70   General/ssh.scala
    71   General/symbol.scala
    72   General/time.scala
    73   General/timing.scala
    74   General/untyped.scala
    75   General/url.scala
    76   General/utf8.scala
    77   General/value.scala
    78   General/word.scala
    79   General/xz.scala
    80   Isar/document_structure.scala
    81   Isar/keyword.scala
    82   Isar/line_structure.scala
    83   Isar/outer_syntax.scala
    84   Isar/parse.scala
    85   Isar/token.scala
    86   ML/ml_console.scala
    87   ML/ml_lex.scala
    88   ML/ml_process.scala
    89   ML/ml_statistics.scala
    90   ML/ml_syntax.scala
    91   PIDE/command.scala
    92   PIDE/command_span.scala
    93   PIDE/document.scala
    94   PIDE/document_id.scala
    95   PIDE/editor.scala
    96   PIDE/line.scala
    97   PIDE/markup.scala
    98   PIDE/markup_tree.scala
    99   PIDE/protocol.scala
   100   PIDE/protocol_handlers.scala
   101   PIDE/protocol_message.scala
   102   PIDE/prover.scala
   103   PIDE/query_operation.scala
   104   PIDE/rendering.scala
   105   PIDE/resources.scala
   106   PIDE/session.scala
   107   PIDE/text.scala
   108   PIDE/xml.scala
   109   PIDE/yxml.scala
   110   ROOT.scala
   111   System/bash.scala
   112   System/command_line.scala
   113   System/cygwin.scala
   114   System/distribution.scala
   115   System/getopts.scala
   116   System/invoke_scala.scala
   117   System/isabelle_charset.scala
   118   System/isabelle_process.scala
   119   System/isabelle_system.scala
   120   System/isabelle_tool.scala
   121   System/numa.scala
   122   System/options.scala
   123   System/platform.scala
   124   System/posix_interrupt.scala
   125   System/process_result.scala
   126   System/progress.scala
   127   System/system_channel.scala
   128   Thy/html.scala
   129   Thy/present.scala
   130   Thy/sessions.scala
   131   Thy/thy_document_model.scala
   132   Thy/thy_header.scala
   133   Thy/thy_syntax.scala
   134   Tools/bibtex.scala
   135   Tools/build.scala
   136   Tools/build_docker.scala
   137   Tools/check_keywords.scala
   138   Tools/debugger.scala
   139   Tools/doc.scala
   140   Tools/imports.scala
   141   Tools/main.scala
   142   Tools/print_operation.scala
   143   Tools/profiling_report.scala
   144   Tools/server.scala
   145   Tools/simplifier_trace.scala
   146   Tools/spell_checker.scala
   147   Tools/task_statistics.scala
   148   Tools/update_cartouches.scala
   149   Tools/update_header.scala
   150   Tools/update_then.scala
   151   Tools/update_theorems.scala
   152   library.scala
   153   term.scala
   154   term_xml.scala
   155   ../Tools/Graphview/graph_file.scala
   156   ../Tools/Graphview/graph_panel.scala
   157   ../Tools/Graphview/graphview.scala
   158   ../Tools/Graphview/layout.scala
   159   ../Tools/Graphview/main_panel.scala
   160   ../Tools/Graphview/metrics.scala
   161   ../Tools/Graphview/model.scala
   162   ../Tools/Graphview/mutator.scala
   163   ../Tools/Graphview/mutator_dialog.scala
   164   ../Tools/Graphview/mutator_event.scala
   165   ../Tools/Graphview/popups.scala
   166   ../Tools/Graphview/shapes.scala
   167   ../Tools/Graphview/tree_panel.scala
   168   ../Tools/VSCode/src/build_vscode.scala
   169   ../Tools/VSCode/src/channel.scala
   170   ../Tools/VSCode/src/document_model.scala
   171   ../Tools/VSCode/src/dynamic_output.scala
   172   ../Tools/VSCode/src/grammar.scala
   173   ../Tools/VSCode/src/preview_panel.scala
   174   ../Tools/VSCode/src/protocol.scala
   175   ../Tools/VSCode/src/server.scala
   176   ../Tools/VSCode/src/state_panel.scala
   177   ../Tools/VSCode/src/vscode_javascript.scala
   178   ../Tools/VSCode/src/vscode_rendering.scala
   179   ../Tools/VSCode/src/vscode_resources.scala
   180   ../Tools/VSCode/src/vscode_spell_checker.scala
   181 )
   182 
   183 
   184 ## diagnostics
   185 
   186 PRG="$(basename "$0")"
   187 
   188 function usage()
   189 {
   190   echo
   191   echo "Usage: isabelle $PRG [OPTIONS]"
   192   echo
   193   echo "  Options are:"
   194   echo "    -f           fresh build"
   195   echo
   196   exit 1
   197 }
   198 
   199 function fail()
   200 {
   201   echo "$1" >&2
   202   exit 2
   203 }
   204 
   205 [ -z "$ISABELLE_HOME" ] && fail "Missing Isabelle settings environment"
   206 
   207 
   208 ## process command line
   209 
   210 # options
   211 
   212 FRESH=""
   213 
   214 while getopts "f" OPT
   215 do
   216   case "$OPT" in
   217     f)
   218       FRESH=true
   219       ;;
   220     \?)
   221       usage
   222       ;;
   223   esac
   224 done
   225 
   226 shift $(($OPTIND - 1))
   227 
   228 
   229 # args
   230 
   231 [ "$#" -ne 0 ] && usage
   232 
   233 
   234 ## build
   235 
   236 TARGET_DIR="$ISABELLE_HOME/lib/classes"
   237 TARGET="$TARGET_DIR/Pure.jar"
   238 
   239 declare -a UPDATED=()
   240 
   241 if [ -n "$FRESH" ]; then
   242   OUTDATED=true
   243 else
   244   OUTDATED=false
   245   if [ ! -e "$TARGET" ]; then
   246     OUTDATED=true
   247   else
   248     for DEP in "${SOURCES[@]}"
   249     do
   250       [ ! -e "$DEP" ] && fail "Missing file: $DEP"
   251       [ "$DEP" -nt "$TARGET" ] && {
   252         OUTDATED=true
   253         UPDATED["${#UPDATED[@]}"]="$DEP"
   254       }
   255     done
   256   fi
   257 fi
   258 
   259 if [ "$OUTDATED" = true ]
   260 then
   261   echo "### Building Isabelle/Scala ..."
   262 
   263   [ "${#UPDATED[@]}" -gt 0 ] && {
   264     echo "Changed files:"
   265     for FILE in "${UPDATED[@]}"
   266     do
   267       echo "  $FILE"
   268     done
   269   }
   270 
   271   rm -f "$TARGET"
   272   rm -rf classes && mkdir classes
   273 
   274   SCALAC_OPTIONS="$ISABELLE_SCALAC_OPTIONS -d classes"
   275 
   276   (
   277     classpath "$JAVA_HOME/lib/jfxrt.jar"
   278     classpath classes
   279     export CLASSPATH="$(platform_path "$ISABELLE_CLASSPATH")"
   280 
   281     isabelle_scala scalac $SCALAC_OPTIONS "${SOURCES[@]}" || \
   282       fail "Failed to compile sources"
   283   ) || exit "$?"
   284 
   285   mkdir -p "$TARGET_DIR" || fail "Failed to create directory $TARGET_DIR"
   286 
   287   pushd classes >/dev/null
   288 
   289   CHARSET_SERVICE="META-INF/services/java.nio.charset.spi.CharsetProvider"
   290   mkdir -p "$(dirname "$CHARSET_SERVICE")"
   291   echo isabelle.Isabelle_Charset_Provider > "$CHARSET_SERVICE"
   292 
   293   cp "$ISABELLE_HOME/lib/logo/isabelle_transparent-32.gif" isabelle/.
   294   cp "$ISABELLE_HOME/lib/logo/isabelle_transparent.gif" isabelle/.
   295 
   296   isabelle_jdk jar cfe "$(platform_path "$TARGET")" isabelle.Main META-INF isabelle || \
   297     fail "Failed to produce $TARGET"
   298 
   299   popd >/dev/null
   300 
   301   rm -rf classes
   302 fi